COTS3/urls.py
from django.contrib import admin
from django.urls import path, include
import backend.urls as backend

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(backend, namespace='backend')),
]

backend/urls.py
from django.conf.urls import url
from django.views.generic.base import RedirectView
from .views import *
#url for app
app_name = 'backend'

urlpatterns = [
    url(r'^$', RedirectView.as_view(url='index/', permanent = False), name='$'),
    url(r'index/', index, name='index'),
    url(r'progress/', progress, name='progress'),
    url(r'download/', download, name='download'),
]

backend/models.py
from django.db import models

# Create your models here.

backend/views.py
from django.http import FileResponse
from background_task import background
from django.shortcuts import render

import pika
import wget

def index(request):
    response = {}
    return render(request, 'home.html', response)

def progress(request):
    response = {}
    if request.POST:
        url = request.POST['url']
        downloadFromUrl(url)
    return render(request, 'progress.html', response)
    
@background(schedule=1)
def downloadFromUrl(url):
    filename = wget.download(url, bar=bar_custom)
    sendMessage('URL to download: <a>http://152.118.148.95:20457/download/?filename=' + filename + '</a>')

def bar_custom(current, total, width=80):
    message = "Downloading: %d%% [%d / %d] bytes" % (current / total * 100, current, total)
    print(message)
    sendMessage(message)

def sendMessage(message):
    routing_key = 'routingabcd12345'
    credentials = pika.PlainCredentials('0806444524', '0806444524')
    connectionParameters = pika.ConnectionParameters('152.118.148.95', 5672, '/0806444524', credentials)
    connection = pika.BlockingConnection(connectionParameters)
    channel = connection.channel()
    channel.exchange_declare(exchange='1606831035', exchange_type='direct')
    channel.queue_declare(queue='Routingabcd')
    channel.basic_publish(exchange='1606831035', routing_key=routing_key, body=message)
    print(" [x] Sent %r:%r" % (routing_key, message))
    connection.close()

def download(request):
    filename = request.GET['filename']
    file = open(filename, 'rb')
    return FileResponse(file)

templates/home.html
<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="theme-color" content="#342345">
  <title> {% block title %} COTS 3 of LAW_KEMAS {% endblock %}</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
  <link href='https://fonts.googleapis.com/css?family=Raleway:900|Raleway' rel='stylesheet'>
  <meta name="viewport" content="initial-scale=1.0, width=device-width" />
</head>

<body>
  <header>
  </header>
  <content>
    <section name="container" class="content">
    <h1>COTS 3</h1>
    <br>
    <h2>Input URL</h2>
    <form id="form" name="form" method="POST" action="{% url 'backend:progress' %}" enctype="multipart/form-data">
      {% csrf_token %}
      <input type="text" name="url" placeholder="Url...">
      <button type="submit">Submit</button>
    </form>
  </content>
  <footer>
  </footer>

</body>

templates/progress.html
<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="theme-color" content="#342345">
  <title> {% block title %} COTS 3 of LAW_KEMAS {% endblock %}</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
  <link href='https://fonts.googleapis.com/css?family=Raleway:900|Raleway' rel='stylesheet'>
  <meta name="viewport" content="initial-scale=1.0, width=device-width" />
</head>

<body>
  <header>
  </header>
  <content>
    <section name="container" class="content">
    <h1>COTS 3 Progress</h1>
    <br>
    <h3>Status:</h3>
    <br>
    <p id="status">Download is starting... please wait</p>
  </content>
  <footer>
  </footer>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/sockjs-client/1.1.4/sockjs.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/stomp.js/2.3.3/stomp.min.js"></script>
  <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
  <script type = "text/javascript">
    WebSocketImplementation();
    function WebSocketImplementation() {
      if ("WebSocket" in window) {
        var routing_key = 'routingabcd12345';
        var ws_stomp_display = new SockJS('http://152.118.148.95:15674/stomp');
        var client_display = Stomp.over(ws_stomp_display);
        var mq_queue_display = "/exchange/1606831035/" + routing_key;
        var on_connect_display = function() {
          console.log('connected');
          client_display.subscribe(mq_queue_display, on_message_display);
        };
        var on_error_display = function() {
          console.log('error');
        };
        var on_message_display = function(m) {
          console.log('message received');
          $('#status').html(m.body);
        };
        client_display.connect('0806444524', '0806444524', on_connect_display, on_error_display, '/0806444524');
      } else {
        alert("WebSocket NOT supported by your Browser!");
      }
    }
  </script>

</body>